/* Todd Martinez
 * October 4, 2002
 * Comp 1671
 * Project 4
 * This program will find and count all the prime numbers less than a number
 * inputted by the user
 */

#include<iostream>
#include<cmath>       //allows use of the sqrt function

using namespace std;

int main()
{
    //declare all variables
    int number;
    int upperLimit;
    int factor;
    int primecounter;
    bool isPrime;
    char response;
    bool GoAgain;
    bool isValid;

    //displays a message stating the purpose of the program
    cout << "This program will find all the prime numbers less than a "
         << "limit you specify." << endl << endl;
	
    //loops as long as the user wishes to continue
    do
    {

	//loops until user inputs a valid number    
    	do
    	{
	    //prompts user for the limit and stores	
            cout << "Choose an integer greater than or equal to 2: ";
            cin >> upperLimit;

	    //display error message if invalid number is input
            if (upperLimit >= 2)
		isValid = true;
	    else
	    {
	        cout << "Invalid Input!\n";
		isValid = false;
	    }
	
	//loops if valid number is input    
	}while (isValid == false);


	//displays a message to introduce the list of primes
	cout << endl;
	cout << "These are the primes less than or equal to " 
	     << upperLimit << ": \n";

	number = 2;          //sets the first number to be checked for 
	                     //primality as 2
	primecounter = 0;    //sets the counter of prime numbers to zero

	//loops to check each number up until the limit for primality
	for (number = 2 ; number <= upperLimit ; number++)
    	{
            factor = 2;      //sets the first factor to test primality as 2
	    isPrime = true;  //says that number is initially considered prime
	                     //until proven otherwise
		
	    //loops until primality is proven false or the factor reaches the
	    //square root
	    while (isPrime == true && 
	           factor <= sqrt(static_cast<float>(number)))
	    {
                //sets primality equal to false if a factor is found
		if (number%factor == 0)
	   	    isPrime = false;
		
		//increments the factor
		factor++;
  	    } 
	
	    //displays a number if is is prime and sets up appropriate 
	    //spacing
	    if (isPrime == true)
  	    {
		//inserts a comma and space as long as it isn't the first 
		//number    
	        if (primecounter != 0)
	   	    cout << ", ";

		//inserts a carriage return every 10 numbers
		if (primecounter%10 == 0)
		    cout << endl;
	  	
		cout << number;   //displays the prime number
	 	
		primecounter++;   //increments the prime counter
	
	    }
        }

	cout << endl << endl;

	//displays a message that says how many primes have been found
	cout << "There are " << primecounter << " prime numbers less than or "
	     <<"equal to "<< upperLimit << endl << endl;

	//checks to see if the user wants to continue
   	do
	{
	    //prompts user to continue and stores response
	    cout << "Would you like to go again? (y/n): ";
	    cin >> response;

	    //determines what to do in the case of each response
	    switch(response)
	    {
		//tells program repeat if user enters 'y' or 'Y'    
		case 'Y':                            
		case 'y':
	       	    GoAgain = true;		
		    cout << endl;
		    break;

		//tells program end if user enters 'n' or 'N'    
		case 'N':
		case 'n':
		    GoAgain = false;
		    break;
		
		//outputs an error if the response was invalid    
		default:
		    cout << "Invalid response!\n";
		    break;
	    }
						
	//loops while response is invalid until user inputs a valid response				
	}while (!(response == 'y' || response == 'Y' ||   
		response == 'n' || response == 'N'));

    //loops while user wishes to go again
    }while (GoAgain == true);
	
    //tells the computer that the program completed successfully
    return 0;
}

